package zclystal.common.item;

import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import zclystal.common.core.ZCrystalCore;

public class ItemZCrystal extends Item {

	//右クリックしないでもう一度飛び立てる制限時間=再飛行可能時間
	private static int canflytime = 0;
	//空中に連続でいる時間
	private static int flyingtime = 0;

	public ItemZCrystal () {
		super();
	}

	//アイテムがインベントリにある際に呼ばれる
	@Override
	public void onUpdate(ItemStack itemstack, World world, Entity entity, int slot, boolean isHeld) {

		//プレイヤーが宙に浮いているか
		if (!entity.onGround) {
			//浮いているならば、flyingtimeに1加算
			flyingtime ++;
		} else {
			//地面にいるなら、flyingtimeをリセット
			flyingtime = 0;

			//再飛行可能時間が残っているか
			if (canflytime > 0) {
				//残っているならば、再飛行可能時間を1減算
				canflytime --;
			} else {
				//残っていないならば、飛行不可にして、再飛行可能時間をリセット
				ZCrystalCore.canfly = false;
				canflytime = 0;
			}
		}

		//連続で120 tick以上飛んでいるか
		if (flyingtime >= 120) {
			//そうなら、ダメージを与えて、flyingtimeを中間リセット
			itemstack.damageItem(1, (EntityLivingBase) entity);
			flyingtime = 80;
		}

		//残りダメージがあるか
		if (this.getDamage(itemstack) == itemstack.getMaxDamage()) {
			//ないなら、飛行不可にする。
			ZCrystalCore.canfly = false;
		}

	}

	//アイテムが右クリックされた際に呼ばれる
	@Override
	public ItemStack onItemRightClick (ItemStack itemstack, World world, EntityPlayer entityplayer) {
		//飛行可能にし、ダメージを与える
		ZCrystalCore.canfly = true;
		itemstack.damageItem(1, entityplayer);

		//再飛行可能時間を設定
		canflytime = 1200;

		return itemstack;
	}

}
